/*
 * JORAM: Java(TM) Open Reliable Asynchronous Messaging
 * Copyright (C) 2013 - 2019 ScalAgent Distributed Technologies
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): ScalAgent Distributed Technologies
 * Contributor(s):
 */
package org.objectweb.joram.mom.proxies;

import org.junit.Assert;

import java.util.Vector;

import org.junit.Test;
import org.objectweb.joram.mom.util.MessageIdListImpl;

public class MessageIdListImplEncodingTest {
  static int lsize = 3;
  static Vector<String> lcontent = new Vector<String>();
  
  @Test
  public void run() throws Exception {
    EncodingHelper.init();

    MessageIdListImpl list = new MessageIdListImpl("testList");
    
    for (int i = 0; i < lsize; i++) {
      String str = "msg" + i;
      list.add(str, true);
      lcontent.add(str);
    }
    // Verify the created list
    Assert.assertEquals(list.size(), lsize);
    for (int i = 0; i < lsize; i++) {
      Assert.assertEquals(list.get(i), lcontent.get(i));
    }
    // Verify the list after encoding and decoding
    checkEncoding(list, lsize);
  }

  private void checkEncoding(MessageIdListImpl list, int lsize) throws Exception {
    byte[] bytes = EncodingHelper.encode(list);
    MessageIdListImpl listDec = (MessageIdListImpl) EncodingHelper.decode(list.getEncodableClassId(), bytes);

    Assert.assertEquals(list.size(), listDec.size());
    for (int i = 0; i < list.size(); i++) {
      Assert.assertEquals(list.get(i), listDec.get(i));
    }
  }

}
